// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_UK2Node_Variable.h"

#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{
	class ISCW_UScriptStruct;
	class ISCW_UK2Node_StructOperation : public virtual ISCW_UK2Node_Variable
	{
	public:
		virtual ~ISCW_UK2Node_StructOperation() = default;

		virtual shared_ptr<ISCW_UScriptStruct> GetStructType() const = 0;

		virtual void SetStructType(shared_ptr<ISCW_UScriptStruct> InStruct) = 0;
		
		virtual std::shared_ptr<ISCW_UK2Node_StructOperation> ToUK2Node_StructOperationPtr() = 0;
		virtual std::shared_ptr<const ISCW_UK2Node_StructOperation> ToUK2Node_StructOperationPtr() const = 0;
	};

	using ISCW_UK2Node_StructOperationConstPtr = std::shared_ptr<const ISCW_UK2Node_StructOperation>;
	using ISCW_UK2Node_StructOperationPtr = std::shared_ptr<ISCW_UK2Node_StructOperation>;
} // namespace Sourcify